;        3,6V
;  
;   - (0,150,1) ,
; - (188) .
;     - 1 ,
;    -   1000 .
;01.03.2019       SI2323
; 26.02.2019    .  0,15     
;  .

	.INCLUDE "m8515def.inc"
.def	ZERO=R15

.equ	Fo=3277568*6	; 3277558*6	119'999'988    
.equ	N=15*Fo/600/100

.CSEG
.ORG 0x0000
RESET:
	CLR	ZERO
	LDI	R19,$FD
	RJMP	START
;***********************************
.ORG 0x0004
T1_COMPA:
	SUBI	R31,BYTE1(N)
	SBCI	R30,BYTE2(N)
	SBCI	R29,BYTE3(N)
	BRPL	NO_MINUTE

	SBIC	PORTE,2
	RJMP	MINUTE

	EOR	R19,R18
	OUT	PORTB,R19		;  150      IR4427
	OUT	PORTD,R16		;     -

	OUT	OCR1AH,R20
	OUT	OCR1AL,R21

	SBI	PORTE,2

	RETI
MINUTE:
	SET
NO_MINUTE:
	RETI
;***********************************
;***********************************
;***********************************
;***********************************
STOP:
	OUT	TCCR1B,ZERO
	OUT	TCNT1H,ZERO
	OUT	TCNT1L,ZERO
;***********************************
START:
	SER	R16
	OUT	DDRB,R16
	OUT	DDRD,R16

	OUT	PORTA,R16
	OUT	PORTC,R16
	OUT	DDRA,R16
	OUT	DDRC,R16
	OUT	DDRE,R16
	OUT	PORTE,R16

	CBI	PORTE,2			;   "KEY STOP"
	CBI	DDRE,0

	OUT	SPH,ZERO
	OUT	SPL,R16
	LDI	R18,0b00000011

	SBI	ACSR,ACD

GO_RAB:
	LDI	R29,BYTE3(Fo/10-2*N-2)
	LDI	R30,BYTE2(Fo/10-2*N-2)
	LDI	R31,BYTE1(Fo/10-2*N-2)	; 59,8 

	LDI	R20,HIGH(Fo/10-N*399-6)
	LDI	R21,LOW(Fo/10-N*399-6)

	LDI	R24,HIGH(N-1)
	LDI	R25,LOW(N-1)
	OUT	OCR1AH,R24
	OUT	OCR1AL,R25

	LDI	R24,1<<SE		;  SLEEP IDLE
	OUT	MCUCR,R24

	LDI	R24,1<<OCIE1A;|1<<OCIE1B
	OUT	TIMSK,R24
	OUT	TIFR,R24

	LDI	R24,1<<WGM12|1<<CS10
	OUT	TCCR1B,R24				;  CTC

	CLT
	SEI
;********************
WAIT_1MIN:
	SLEEP

	SBIS	PINE,0
	RJMP	STOP
	BRTC	WAIT_1MIN
	OUT		PORTB,ZERO
	OUT		PORTD,ZERO
	RJMP	START			;  1 

.EXIT
